/* Copyright (c) 2002-2006, The Ohio State University. All rights
 * reserved.
 * 
 * This file is part of the MVAPICH software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 * 
 * For detailed copyright and licencing information, please refer to the
 * copyright file COPYRIGHT_MVAPICH in the top level MPICH directory.
 *
 */

#ifndef _IBVERBS_CONST_H
#define _IBVERBS_CONST_H

#ifdef _IA32_
    #ifdef _SMALL_CLUSTER
    #define VIADEV_NUM_RDMA_BUFFER            (32)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (VBUF_BUFFER_SIZE - \
            sizeof(viadev_packet_eager_start))
    #elif defined (_MEDIUM_CLUSTER)
    #define VIADEV_NUM_RDMA_BUFFER            (16)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (16384)
    #elif defined (_LARGE_CLUSTER)
    #define VIADEV_NUM_RDMA_BUFFER            (16)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (16384)
    #else
    #define VIADEV_NUM_RDMA_BUFFER            (32)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (VBUF_BUFFER_SIZE - \
            sizeof(viadev_packet_eager_start))
    #endif
#elif defined (_EM64T_)
    #ifdef _SMALL_CLUSTER
    #define VIADEV_NUM_RDMA_BUFFER            (32)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (VBUF_BUFFER_SIZE - \
            sizeof(viadev_packet_eager_start))
    #elif defined (_MEDIUM_CLUSTER)
    #define VIADEV_NUM_RDMA_BUFFER            (16)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (VBUF_BUFFER_SIZE - \
            sizeof(viadev_packet_eager_start))
    #elif defined (_LARGE_CLUSTER)
    #define VIADEV_NUM_RDMA_BUFFER            (8)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (8192)
    #else
    #define VIADEV_NUM_RDMA_BUFFER            (32)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (VBUF_BUFFER_SIZE - \
            sizeof(viadev_packet_eager_start))
    #endif
#elif defined (_IA64_)
    #ifdef _SMALL_CLUSTER
    #define VIADEV_NUM_RDMA_BUFFER            (32)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (VBUF_BUFFER_SIZE - \
            sizeof(viadev_packet_eager_start))
    #elif defined (_MEDIUM_CLUSTER)
    #define VIADEV_NUM_RDMA_BUFFER            (16)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (16384)
    #elif defined (_LARGE_CLUSTER)
    #define VIADEV_NUM_RDMA_BUFFER            (16)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (8192)
    #else
    #define VIADEV_NUM_RDMA_BUFFER            (32)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (VBUF_BUFFER_SIZE - \
            sizeof(viadev_packet_eager_start))
    #endif
#elif defined (_X86_64_)
    #ifdef _SMALL_CLUSTER
    #define VIADEV_NUM_RDMA_BUFFER            (32)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (VBUF_BUFFER_SIZE - \
            sizeof(viadev_packet_eager_start))
    #elif defined (_MEDIUM_CLUSTER)
    #define VIADEV_NUM_RDMA_BUFFER            (16)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (16384)
    #elif defined (_LARGE_CLUSTER)
    #define VIADEV_NUM_RDMA_BUFFER            (16)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (8192)
    #else
    #define VIADEV_NUM_RDMA_BUFFER            (32)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (VBUF_BUFFER_SIZE - \
            sizeof(viadev_packet_eager_start))
    #endif
#elif defined (MAC_OSX)
    #ifdef _SMALL_CLUSTER
    #define VIADEV_NUM_RDMA_BUFFER            (128)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (VBUF_BUFFER_SIZE - \
            sizeof(viadev_packet_eager_start))
    #elif defined (_MEDIUM_CLUSTER)
    #define VIADEV_NUM_RDMA_BUFFER            (64)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (16384)
    #elif defined (_LARGE_CLUSTER)
    #define VIADEV_NUM_RDMA_BUFFER            (32)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (8192)
    #else
    #define VIADEV_NUM_RDMA_BUFFER            (128)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (VBUF_BUFFER_SIZE - \
            sizeof(viadev_packet_eager_start))
    #endif
#elif defined (SOLARIS)
    #ifdef _SMALL_CLUSTER
    #define VIADEV_NUM_RDMA_BUFFER            (32)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (VBUF_BUFFER_SIZE - \
            sizeof(viadev_packet_eager_start))
    #elif defined (_MEDIUM_CLUSTER)
    #define VIADEV_NUM_RDMA_BUFFER            (16)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (16384)
    #elif defined (_LARGE_CLUSTER)
    #define VIADEV_NUM_RDMA_BUFFER            (16)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (16384)
    #else
    #define VIADEV_NUM_RDMA_BUFFER            (32)
    #define DEFAULT_RENDEZVOUS_THRESHOLD      (VBUF_BUFFER_SIZE - \
            sizeof(viadev_packet_eager_start))
    #endif
#endif

#define HOSTNAME_LEN                (255)
#define DEFAULT_HCA_PORT            (1)
#define DEFAULT_MAX_CQ_SIZE         (40000)
#define DEFAULT_MAX_SEND_WQE        (4096)
#define DEFAULT_MAX_RECV_WQE        (4096)
#define DEFAULT_MAX_SEND_SGE        (1)
#define DEFAULT_MAX_RECV_SGE        (1)

#if (defined(_MLX_PCI_EX_DDR_) || defined(_IBM_EHCA_))

    #define DEFAULT_MTU                (IBV_MTU_2048)

#else

    #define DEFAULT_MTU                (IBV_MTU_1024)

#endif

#ifdef _DDR_

    #define DEFAULT_MTU                (IBV_MTU_2048)

#elif _SDR_

    #define DEFAULT_MTU                (IBV_MTU_1024)

#endif

#define DEFAULT_MAX_RDMA_SIZE       (1048576)
#define DEFAULT_PSN                 (0)
#define DEFAULT_DEST_RD_ATOMIC      (1)
#define DEFAULT_MIN_RNR_TIMER       (12)
#define DEFAULT_SERVICE_LEVEL       (0)
#define DEFAULT_SRC_PATH_BITS       (0)
#define DEFAULT_TIMEOUT             (14)
#define DEFAULT_RETRY_COUNT         (7)
#define DEFAULT_RNR_RETRY           (7)
#ifdef _PPC64_
#define MAX_INLINE_SIZE             (-1)
#else
#define MAX_INLINE_SIZE             (128)
#endif
#define NUM_RDMA_BUFFER             (32)
#define VBUF_POOL_SIZE              (8000)
#define MAX_VBUFS                   (-1)
#define DEFAULT_NDREG_ENTERIES      (4000)
#define INITIAL_PREPOST_DEPTH       (32)
#define INITIAL_CREDITS             (64)
#define PREPOST_DEPTH               (128)
#define PREPOST_NOOP_EXTRA          (1)
#define VBUF_SECONDARY_POOL_SIZE    (2000)
#define PREPOST_THRESHOLD           (10)
#define PREPOST_RENDEZVOUS_EXTRA    (10)
#define RENDEZVOUS_THRESHOLD        (VBUF_BUFFER_SIZE - \
        sizeof(viadev_packet_eager_start))
#define CREDIT_PRESERVE             (5)
#define DYNAMIC_CREDIT_THRESHOLD    (20)
#define CREDIT_NOTIFY_THRESHOLD     (5)
#define DEFAULT_STATIC_RATE         (0)
#define VIADEV_DEFAULT_DEVICE                 "mthca0"
#define MAX_PORTS       (2)

#endif /* _IBVERBS_CONST_H */
