
/* Copyright (c) 2002-2006, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licencing information, please refer to the
 * copyright file COPYRIGHT_MVAPICH in the top level MPICH directory.
 *
 */

#ifndef _RDMA_FAST_PATH_H
#define _RDMA_FAST_PATH_H

#include "ibverbs_header.h"
#include "viapriv.h"
#include "vbuf.h"
#include "mpid.h"

#ifdef RDMA_FAST_PATH

void init_rdma_fast_path(ibv_connection_t*);
void finalize_rdma_fast_path(void);
void rdma_buffer_address_exchange(void);

#else

#define init_rdma_fast_path(void)
#define finalize_rdma_fast_path(void)
#define rdma_buffer_address_exchange(void)

#endif /* RDMA_FAST_PATH */

#endif /* _RDMA_FAST_PATH_H */
