/*
 * Copyright (C) 1999-2001 The Regents of the University of California
 * (through E.O. Lawrence Berkeley National Laboratory), subject to
 * approval by the U.S. Department of Energy.
 *
 * Use of this software is under license. The license agreement is included
 * in the file MVICH_LICENSE.TXT.
 *
 * Developed at Berkeley Lab as part of MVICH.
 *
 * Authors: Bill Saphir      <wcsaphir@lbl.gov>
 *          Michael Welcome  <mlwelcome@lbl.gov>
 */

/* Copyright (c) 2002-2006, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licencing information, please refer to the
 * copyright file COPYRIGHT_MVAPICH in the top level MPICH directory.
 *
 */


#ifndef _VIUTIL_H
#define _VIUTIL_H

#include "udapl_header.h"
#include <string.h>
#include <errno.h>
#include <stdio.h>
#include "viapriv.h"
#include "process/pmgr_client.h"

#define GEN_EXIT_ERR     -1     /* general error which forces us to abort */
#define GEN_ASSERT_ERR   -2     /* general assert error */
#define UDAPL_RETURN_ERR	  -3    /* uDAPL funtion return error */
#define UDAPL_STATUS_ERR   -4    /* uDAPL funtion status error */
#define udapl_error_abort(code, message, args...)  {              \
    fprintf(stderr, "[%d] Abort: ", viadev.me);                     \
    fprintf(stderr, message, ##args);                               \
    fprintf(stderr, " at line %d in file %s\n", __LINE__, __FILE__);\
    pmgr_abort();                                                   \
    exit(code);                                                     \
}

char *viutil_errorstring(DAT_RETURN code);
void viutil_check_connections(int probe);
double viutil_get_seconds(void);

#endif                          /* _VIUTIL_H */
